<?php
namespace SGalinski\SgJobs\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use TYPO3\CMS\Extbase\Domain\Model\FileReference;
use TYPO3\CMS\Extbase\DomainObject\AbstractEntity;
use TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy;

/**
 * The base model
 */
class Base extends AbstractEntity {
	/**
	 * @var string
	 */
	protected $textField = '';

	/**
	 * @lazy
	 * @var \TYPO3\CMS\Extbase\Domain\Model\FileReference
	 */
	protected $image = '';

	/**
	 * @var string
	 */
	protected $textArea = '';

	/**
	 * @var string
	 */
	protected $textAreaWithRte = '';

	/**
	 * @var boolean
	 */
	protected $checkbox = FALSE;

	/**
	 * @return string
	 */
	public function getTextField() {
		return $this->textField;
	}

	/**
	 * @param string $textField
	 * @return void
	 */
	public function setTextField($textField) {
		$this->textField = $textField;
	}

	/**
	 * @return FileReference
	 */
	public function getImage() {
		if ($this->image instanceof LazyLoadingProxy) {
			$this->image->_loadRealInstance();
		}
		return $this->image;
	}

	/**
	 * @param FileReference $image
	 * @return void
	 */
	public function setImage(FileReference $image) {
		$this->image = $image;
	}

	/**
	 * @return string
	 */
	public function getTextArea() {
		return $this->textArea;
	}

	/**
	 * @param string $textArea
	 * @return void
	 */
	public function setTextArea($textArea) {
		$this->textArea = $textArea;
	}

	/**
	 * @return string
	 */
	public function getTextAreaWithRte() {
		return $this->textAreaWithRte;
	}

	/**
	 * @param string $textAreaWithRte
	 * @return void
	 */
	public function setTextAreaWithRte($textAreaWithRte) {
		$this->textAreaWithRte = $textAreaWithRte;
	}

	/**
	 * @return bool
	 */
	public function getCheckbox() {
		return $this->checkbox;
	}

	/**
	 * @param bool $checkbox
	 * @return void
	 */
	public function setCheckbox($checkbox) {
		$this->checkbox = ($checkbox == TRUE);
	}
}
