<?php
namespace SGalinski\SgJobs\Domain\Repository;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Object\ObjectManager;
use TYPO3\CMS\Extbase\Persistence\Generic\Typo3QuerySettings;
use TYPO3\CMS\Extbase\Persistence\QueryResultInterface;
use TYPO3\CMS\Extbase\Persistence\Repository;

/**
 * Base Repository
 */
class BaseRepository extends Repository {
	/**
	 * Just an example query.
	 *
	 * @param int $pageId
	 * @param bool $checkbox
	 * @return array|QueryResultInterface
	 */
	public function exampleQuery($pageId, $checkbox) {
		$query = $this->createQuery();

		$constraint[] = $query->equals('pid', (int) $pageId);
		$constraint[] = $query->equals('checkbox', TRUE);

		return $query->matching($query->logicalAnd($constraint))->execute();
	}

	/**
	 * Find all entries for backend pagination usage
	 *
	 * @param int $pageId
	 * @param bool $raw
	 * @return array|QueryResultInterface
	 */
	public function findAllBackend($pageId, $raw) {
		$query = $this->createQuery();

		$constraint[] = $query->equals('pid', (int) $pageId);
		/** @var ObjectManager $objectManager */
		$objectManager = GeneralUtility::makeInstance(ObjectManager::class);

		$querySettings = $objectManager->get(Typo3QuerySettings::class);
		/** @var Typo3QuerySettings $querySettings */
		$querySettings->setRespectStoragePage(FALSE);
		$querySettings->setIgnoreEnableFields(TRUE);
		$querySettings->setEnableFieldsToBeIgnored(['disabled', 'starttime', 'endtime']);

		return $query->matching($query->logicalAnd($constraint))->execute($raw);
	}
}
